#!/bin/sh
source ../settings
FILES=`echo src/at/dms/classfile/*.java`
JARFILE=kopi-classfile.jar
NAME="at.dms.classfile"

# First generate ClassfileMessages.java
MSGGEN=$PWD/../msggen/jars/kopi-msggen.jar
(cd src/at/dms/classfile; $JAVA -jar $MSGGEN ClassfileMessages.msg)
echo "Generated ClassfileMessages.java"

# Generate ClassfileOptions.java
OPTGEN=$PWD/../optgen/jars/kopi-optgen.jar
(cd src/at/dms/classfile; $JAVA -jar $OPTGEN ClassfileOptions.opt)
echo "Generated ClassfileOptions.java"

rm -rf classes/at
( $COMPILER -d classes \
       -classpath src:../libs/gnugetopt.jar:../libs/antlr.jar:../util/jars/kopi-util.jar:$JIKESPATH \
       $FILES \
  && echo "Compilation of $NAME finished." \
  && $JAR cmf0 jars/manifest jars/$JARFILE -C classes at \
  && echo "Jar file $JARFILE created.") 2>&1
