#!/bin/sh

source ../settings

# First generate KjcMessages.java
MSGGEN=$PWD/../msggen/jars/kopi-msggen.jar
(cd src/at/dms/kjc; $JAVA -jar $MSGGEN KjcMessages.msg)
echo "Generated KjcMessages.java"

# Generate KjcOptions.java
OPTGEN=$PWD/../optgen/jars/kopi-optgen.jar
(cd src/at/dms/kjc; $JAVA -jar $OPTGEN KjcOptions.opt)
echo "Generated KjcOptions.java"

FILES=`echo src/at/dms/compiler/*.java src/at/dms/kjc/*.java src/at/dms/optimize/*.java src/at/dms/backend/*.java src/at/dms/type/*.java src/at/dms/codegen/jvm/*.java`
JARFILE=kopi-compiler.jar
NAME="at.dms.kjc"

rm -rf classes/at
( $COMPILER -d classes \
       -classpath src:../libs/gnugetopt.jar:../libs/antlr.jar:../util/jars/kopi-util.jar:../classfile/jars/kopi-classfile.jar:$JIKESPATH \
       $FILES \
  && echo "Compilation of $NAME finished." \
  && $JAR cmf0 jars/manifest jars/$JARFILE -C classes at \
  && echo "Jar file $JARFILE created.") 2>&1
