/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.compiler;

import at.dms.util.Utils;

/**
 * This class represents the root class for all elements of the parsing tree.
 */
public abstract class Phylum
    extends Utils
{
    /**
     * Token reference in the source text.
     */
    private TokenReference where;

    /**
     * construct an element of the parsing tree
     * @param where the token reference of this node
     */
    public Phylum(TokenReference where)
    {
        this.where = where;
    }

    /**
     * Returns the token reference of this node in the source text.
     *
     * @return the entire token reference.
     */
    public TokenReference getTokenReference()
    {
        return where;
    }

    /**
     * Change the token reference of this node.
     *
     * @param where the new token reference.
     */
    public void setTokenReference(TokenReference where)
    {
        this.where = where;
    }
}
