/*
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.kjc;

import at.dms.compiler.Compiler;
import at.dms.type.*;
import at.dms.util.Utils;

/**
 * Fake class that implements all interfaces that an array does.
 */
public class CArrayClass
    extends CClass
{
    /**
     * Instance of Compiler for this generated dummy class.
     */
    private static final Compiler FAKE_COMPILER = new EmptyCompiler();

    /**
     * Constructs a class export from file.
     */
    public CArrayClass()
    {
        super(FAKE_COMPILER, null, null, false, ACC_PUBLIC | ACC_FINAL,
              "$Array$", "$Array$", StandardType.OBJECT, false);

        ClassOrInterfaceType[] interfaces = new ClassOrInterfaceType[2];
        interfaces[0] = StandardType.CLONEABLE;
        interfaces[1] = StandardType.SERIALIZABLE;
        close(interfaces, new CField[0], new CMethod[0]);
    }
}
