/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package at.dms.kjc;

import at.dms.type.*;

import java.util.List;

import at.dms.compiler.Compiler;
import at.dms.compiler.PositionedError;
import at.dms.compiler.UnpositionedError;

/**
 * Dummy class to satisfy a not-so-handy class hierarchy.
 */
public class CEmptyTopLevelContext
    extends CCompilationUnitContext
{
    /**
     * Construct a compilation unit context.
     */
    CEmptyTopLevelContext(Compiler compiler)
    {
        super(compiler, null);
    }

    /**
     */
    public int getFieldInfo(CField field)
    {
        return 0;
    }

    /**
     */
    public int getVariableInfo(JLocalVariable variable)
    {
        return 0;
    }

    /**
     *
     */
    public ClassOrInterfaceType lookupClass(CClass access, String name)
        throws UnpositionedError
    {
        ClassOrInterfaceType result = ClassOrInterfaceType.lookup(name);
        if (access == null || result.getCClass().isAccessible(access)) {
            return result;
        }
        else {
            return null;
        }
    }

    /**
     */
    public CContext getParentContext()
    {
        fail();
        return null;
    }

    /**
     */
    public CClassContext getClassContext()
    {
        return null;
    }

    /**
     */
    public CMethodContext getMethod()
    {
        return null;
    }

    /**
     */
    public CCompilationUnitContext getCompilationUnit()
    {
        fail();
        return null;
    }

    public CBlockContext getBlockContext()
    {
        return null;
    }  

    public CClassContext createClassContext(CSourceClass clazz)
    {
        return new CClassContext(this, clazz, null);
    }
  
    /**
     */
    public void addSourceClass(CSourceClass clazz)
    {
        fail();
    }
}
