/*
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.kjc;

import at.dms.classfile.SourceDescription;
import at.dms.compiler.Compiler;
import at.dms.compiler.PositionedError;

/**
 * A fake, empty, Compiler subclass.
 */
class EmptyCompiler
    extends Compiler
{
    public boolean run(String[] args)
    {
                    return true;
    }
    
    public void loadSourceFile(SourceDescription sourceFile)
    {
        throw new RuntimeException("Assertion failed; method " +
                                   "should not ever be called.");
    }                
    
    public void reportTrouble(PositionedError a)
    {
    }
    
    public boolean parseComments()
    {
        return true;
    }
    
    public boolean verboseMode()
    {
        return false;
    }
}
