/* Generated from source file KjcOptions.opt
 * For copyright and licensing information, see the source file.
 */
package at.dms.kjc;

import java.io.PrintStream;

import gnu.getopt.Getopt;
import gnu.getopt.LongOpt;

/**
 * Generated file containing message definitions.
 * Source file: <code>KjcOptions.opt</code>
 */
public class KjcOptions
    extends at.dms.util.Options
{

    public KjcOptions(String name)
    {
        super(name);
    }

    public KjcOptions()
    {
        this("Kjc");
    }
    public boolean beautify = false;
    public boolean verbose = false;
    public boolean java = false;
    public boolean nowrite = false;
    public int warning = 0;
    public boolean nowarn = false;
    public int optimize = 1;
    public boolean deprecation = false;
    public boolean nosystemlib = false;
    public String destination = null;
    public String classpath = null;
    public String encoding = null;
    public boolean debug = false;
    public String lang = "1.2";
    public boolean Xstdout = false;
    public String filter = "at.dms.kjc.DefaultFilter";

    public boolean processOption(int code, Getopt g)
    {
        switch (code) {
        case 'b':
            beautify =
                !false;
            break;
        case 'v':
            verbose =
                !false;
            break;
        case 'j':
            java =
                !false;
            break;
        case 'n':
            nowrite =
                !false;
            break;
        case 'w':
            warning =
                getInt(g, 4);
            break;
        case '*':
            nowarn =
                !false;
            break;
        case 'O':
            optimize =
                getInt(g, 2);
            break;
        case 'D':
            deprecation =
                !false;
            break;
        case 'S':
            nosystemlib =
                !false;
            break;
        case 'd':
            destination =
                getString(g, "");
            break;
        case 'C':
            classpath =
                getString(g, "");
            break;
        case 'e':
            encoding =
                getString(g, "");
            break;
        case 'g':
            debug =
                !false;
            break;
        case 'l':
            lang =
                getString(g, "");
            break;
        case 's':
            Xstdout =
                !false;
            break;
        case 'f':
            filter =
                getString(g, "");
            break;
        default:
            return super.processOption(code, g);
        }
        return true;
    }

    public String[] getOptions()
    {
        String[] parent = super.getOptions();
        String[] total = new String[parent.length + 16];
        System.arraycopy(parent, 0, total, 0, parent.length);
        total[parent.length + 0] = "  --beautify, -b:       Beautifies the source code [false]";
        total[parent.length + 1] = "  --verbose, -v:        Prints out information during compilation [false]";
        total[parent.length + 2] = "  --java, -j:           Generates java source code instead of class [false]";
        total[parent.length + 3] = "  --nowrite, -n:        Only checks files, doesn't generate code [false]";
        total[parent.length + 4] = "  --warning, -w<int>:   Maximal level of warnings to be displayed [0]";
        total[parent.length + 5] = "  --nowarn, -*:         Not used, for compatibility purposes [false]";
        total[parent.length + 6] = "  --optimize, -O<int>:  Optimizes X times [1]";
        total[parent.length + 7] = "  --deprecation, -D:    Tests for deprecated members [false]";
        total[parent.length + 8] = "  --nosystemlib, -S:    Don't look up classes in the JVM's class library [false]";
        total[parent.length + 9] = "  --destination, -d<String>: Writes files to destination";
        total[parent.length + 10] = "  --classpath, -C<String>: Sets the search path for .class files";
        total[parent.length + 11] = "  --encoding, -e<String>: Sets the character encoding used by source files";
        total[parent.length + 12] = "  --debug, -g:          Produces debug information [false]";
        total[parent.length + 13] = "  --lang, -l<String>:   Sets the source language (1.1, 1.2, kopi) [1.2]";
        total[parent.length + 14] = "  --Xstdout, -s:        redirect output listings to stdout [false]";
        total[parent.length + 15] = "  --filter, -f<String>: Warning filter [at.dms.kjc.DefaultFilter]";

        return total;
    }

    public String getShortOptions()
    {
        return "bvjnw::*O::DSd:C:e:gl:sf:" + super.getShortOptions();
    }

    public void version()
    {
        System.out.println("version number: 1.9beta5 21/april/2001");
    }

    public void usage()
    {
        System.err.println("usage: ksusu [option]* [--help] <java-files>");
        version();
    }

    public void help()
    {
        System.err.println("usage: ksusu [option]* [--help] <java-files>");
        printOptions();
        PrintStream err = System.err;
        err.println();
        err.println("This program is originally part of the KOPI suite of Java compilation tools.");
        err.println("For more information on the KOPI suite, see:");
        err.println("http://www.dms.at/kopi");
        version();
  }

    public LongOpt[] getLongOptions()
    {
        LongOpt[] parent = super.getLongOptions();
        LongOpt[] total = new LongOpt[parent.length + LONGOPTS.length];

        System.arraycopy(parent, 0, total, 0, parent.length);
        System.arraycopy(LONGOPTS, 0, total, parent.length, LONGOPTS.length);

        return total;
    }

    private static final LongOpt[] LONGOPTS = {
        new LongOpt("beautify", LongOpt.NO_ARGUMENT, null, 'b'),
        new LongOpt("verbose", LongOpt.NO_ARGUMENT, null, 'v'),
        new LongOpt("java", LongOpt.NO_ARGUMENT, null, 'j'),
        new LongOpt("nowrite", LongOpt.NO_ARGUMENT, null, 'n'),
        new LongOpt("warning", LongOpt.OPTIONAL_ARGUMENT, null, 'w'),
        new LongOpt("nowarn", LongOpt.NO_ARGUMENT, null, '*'),
        new LongOpt("optimize", LongOpt.OPTIONAL_ARGUMENT, null, 'O'),
        new LongOpt("deprecation", LongOpt.NO_ARGUMENT, null, 'D'),
        new LongOpt("nosystemlib", LongOpt.NO_ARGUMENT, null, 'S'),
        new LongOpt("destination", LongOpt.REQUIRED_ARGUMENT, null, 'd'),
        new LongOpt("classpath", LongOpt.REQUIRED_ARGUMENT, null, 'C'),
        new LongOpt("encoding", LongOpt.REQUIRED_ARGUMENT, null, 'e'),
        new LongOpt("debug", LongOpt.NO_ARGUMENT, null, 'g'),
        new LongOpt("lang", LongOpt.REQUIRED_ARGUMENT, null, 'l'),
        new LongOpt("Xstdout", LongOpt.NO_ARGUMENT, null, 's'),
        new LongOpt("filter", LongOpt.REQUIRED_ARGUMENT, null, 'f')
    };
}
