// $ANTLR 2.7.1: "Kjc.g" -> "KjcParser.java"$

package at.dms.kjc;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

import java.util.ArrayList;
import java.util.List;
  
import at.dms.compiler.Compiler;
import at.dms.compiler.CompilerMessages;
import at.dms.compiler.CWarning;
import at.dms.compiler.InputBuffer;
import at.dms.compiler.JavaStyleComment;
import at.dms.compiler.JavadocComment;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;
import at.dms.type.*;
import at.dms.util.Utils;

public class KjcParser extends antlr.LLkParser
       implements KjcTokenTypes
 {

    /**
     * Compiler instance.
     */
    private Compiler compiler;

    /**
     * The scanner used.
     */
    private KjcScanner scanner;

    public KjcParser(Compiler compiler, KjcScanner scanner)
    {
        super(scanner, 2);
        this.compiler = compiler;
        this.scanner = scanner;
    }

    /**
     * Returns the compiler driver which invoked the parser.
     */
    public Compiler getCompiler()
    {
        return compiler;
    }

    /**
     * Returns the input buffer.
     */
    public final InputBuffer getBuffer()
    {
        return scanner.getBuffer();
    }

    /**
     * Returns a reference to the current position in the source file.
     */
    protected final TokenReference buildTokenReference()
    {
        return scanner.getTokenReference();
    }

    /**
     *
     */
    protected final JavaStyleComment[] getStatementComment()
    {
        return scanner.getStatementComment();
    }

    /**
     *
     */
    protected final JavadocComment getJavadocComment()
    {
        return scanner.getJavadocComment();
    }

    /**
     *
     */
    protected List getComment()
    {
        return null; // scanner.getComment();
    }

    /**
     * Reports that an error has been detected in the lexical analyser.
     * The handling is delegated to the compiler driver.
     *
     * @param error
     * The error to report.
     */
    protected final void reportTrouble(PositionedError trouble)
    {
        compiler.reportTrouble(trouble);
    }

    /**
     * Generate an human readable error message.
     */
    public PositionedError beautifyParseError(antlr.RecognitionException e)
    {
        if (e instanceof NoViableAltException) {
            NoViableAltException nva = (NoViableAltException)e;
            Token t = nva.token;
        }

        String message = e.toString(); // can do better

        if (message == null) {
            message = "unknown";
        }
        else {
            int idx = message.indexOf(",");

            if (idx >= 0) {
                message = message.substring(idx + 1);
            }
        }

        return new PositionedError(scanner.getTokenReference(),
                                   CompilerMessages.SYNTAX_ERROR, message);
    }

protected KjcParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public KjcParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected KjcParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public KjcParser(TokenStream lexer) {
  this(lexer,2);
}

public KjcParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final JCompilationUnit  jCompilationUnit(
		
	) throws RecognitionException, TokenStreamException {
		JCompilationUnit self = null;
		
		
		TokenReference sourceRef = buildTokenReference();
		JPackageName pack = JPackageName.UNNAMED;
		CParseCompilationUnitContext context =
		CParseCompilationUnitContext.getInstance();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_package:
		{
			pack=jPackageDefinition();
			break;
		}
		case EOF:
		case SEMI:
		case LITERAL_import:
		case LITERAL_public:
		case LITERAL_protected:
		case LITERAL_private:
		case LITERAL_static:
		case LITERAL_abstract:
		case LITERAL_final:
		case LITERAL_native:
		case LITERAL_synchronized:
		case LITERAL_strictfp:
		case LITERAL_transient:
		case LITERAL_volatile:
		case LITERAL_class:
		case LITERAL_interface:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			context.setPackage(pack);
		}
		{
		_loop4:
		do {
			if ((LA(1)==LITERAL_import)) {
				jImportDefinition(context);
			}
			else {
				break _loop4;
			}
			
		} while (true);
		}
		{
		_loop6:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				jTypeDefinition(context);
			}
			else {
				break _loop6;
			}
			
		} while (true);
		}
		match(Token.EOF_TYPE);
		if ( inputState.guessing==0 ) {
			
			self = new JCompilationUnit(sourceRef, pack,
			context.getPackageImports(),
			context.getClassImports(),
			context.getTypeDeclarations());
			context.release();
			
		}
		return self;
	}
	
	public final JPackageName  jPackageDefinition(
		
	) throws RecognitionException, TokenStreamException {
		JPackageName self = null;
		
		
		String  name = null;
		
		
		match(LITERAL_package);
		name=jIdentifier();
		match(SEMI);
		if ( inputState.guessing==0 ) {
			
			self = new JPackageName(buildTokenReference(),
			name, getStatementComment());
			
		}
		return self;
	}
	
	public final void jImportDefinition(
		CParseCompilationUnitContext cunit
	) throws RecognitionException, TokenStreamException {
		
		Token  i = null;
		Token  j = null;
		
		StringBuffer buffer = null;
		boolean      star = false;
		String       name = null;
		
		
		match(LITERAL_import);
		i = LT(1);
		match(IDENT);
		{
		_loop10:
		do {
			if ((LA(1)==DOT) && (LA(2)==IDENT)) {
				match(DOT);
				j = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					
					( buffer == null
					? (buffer = new StringBuffer(i.getText()))
					: buffer
					).append('/').append(j.getText());
					
				}
			}
			else {
				break _loop10;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			name = (buffer == null ? i.getText() : buffer.toString());
			
		}
		{
		switch ( LA(1)) {
		case DOT:
		{
			match(DOT);
			match(STAR);
			if ( inputState.guessing==0 ) {
				star = true;
			}
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			
			if (star) {
			cunit.addPackageImport(new JPackageImport(buildTokenReference(),
			name,
			getStatementComment()));
			}
			else {
			cunit.addClassImport(new JClassImport(buildTokenReference(),
			name,
			getStatementComment()));
			}
			
		}
	}
	
	public final void jTypeDefinition(
		CParseCompilationUnitContext context
	) throws RecognitionException, TokenStreamException {
		
		
		int mods = 0;
		JTypeDeclaration decl = null;
		TokenReference sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_public:
		case LITERAL_protected:
		case LITERAL_private:
		case LITERAL_static:
		case LITERAL_abstract:
		case LITERAL_final:
		case LITERAL_native:
		case LITERAL_synchronized:
		case LITERAL_strictfp:
		case LITERAL_transient:
		case LITERAL_volatile:
		case LITERAL_class:
		case LITERAL_interface:
		{
			mods=jModifiers();
			{
			switch ( LA(1)) {
			case LITERAL_class:
			{
				decl=jClassDefinition(mods);
				break;
			}
			case LITERAL_interface:
			{
				decl=jInterfaceDefinition(mods);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				context.addTypeDeclaration(getCompiler(), decl);
				
			}
			break;
		}
		case SEMI:
		{
			match(SEMI);
			if ( inputState.guessing==0 ) {
				
				reportTrouble(new CWarning(sourceRef,
				KjcMessages.STRAY_SEMICOLON, null));
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
	}
	
	public final String  jIdentifier(
		
	) throws RecognitionException, TokenStreamException {
		String self = null;
		
		Token  i = null;
		Token  j = null;
		
		StringBuffer buffer = null;
		
		
		i = LT(1);
		match(IDENT);
		{
		_loop29:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				j = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					
					(buffer == null
					? (buffer = new StringBuffer(i.getText()))
					: buffer).append('/').append(j.getText());
					
				}
			}
			else {
				break _loop29;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (buffer == null ? i.getText() : buffer.toString());
			
		}
		return self;
	}
	
	public final int  jModifiers(
		
	) throws RecognitionException, TokenStreamException {
		int self = 0;
		
		
		int mod;
		
		
		{
		_loop17:
		do {
			if (((LA(1) >= LITERAL_public && LA(1) <= LITERAL_volatile))) {
				mod=jModifier();
				if ( inputState.guessing==0 ) {
					
					if ((mod & self) != 0) {
					reportTrouble(new PositionedError
					(buildTokenReference(),
					KjcMessages.DUPLICATE_MODIFIER,
					JMemberDeclaration.getModifierName(mod)));
					}
					
					if (!JMemberDeclaration.checkOrder(self, mod)) {
					reportTrouble(new CWarning
					(buildTokenReference(),
					KjcMessages.MODIFIER_ORDER,
					JMemberDeclaration.getModifierName(mod)));
					}
					self |= mod;
					
				}
			}
			else {
				break _loop17;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JClassDeclaration  jClassDefinition(
		int mods
	) throws RecognitionException, TokenStreamException {
		JClassDeclaration self = null;
		
		Token  ident = null;
		
		String superClass = null;
		ClassOrInterfaceType[] interfaces = ClassOrInterfaceType.EMPTY;
		CParseClassContext context = CParseClassContext.getInstance();
		TokenReference sourceRef = buildTokenReference();
		JavadocComment javadoc = getJavadocComment();
		JavaStyleComment[] comments = getStatementComment();
		
		
		match(LITERAL_class);
		ident = LT(1);
		match(IDENT);
		superClass=jSuperClassClause();
		interfaces=jImplementsClause();
		jClassBlock(context);
		if ( inputState.guessing==0 ) {
			
			self = new JClassDeclaration(sourceRef,
			mods,
			ident.getText(),
			superClass,
			interfaces,
			context.getFields(),
			context.getMethods(),
			context.getInnerClasses(),
			context.getBody(),
			javadoc,
			comments);
			context.release();
			
		}
		return self;
	}
	
	public final JInterfaceDeclaration  jInterfaceDefinition(
		int mods
	) throws RecognitionException, TokenStreamException {
		JInterfaceDeclaration self = null;
		
		Token  ident = null;
		
		ClassOrInterfaceType[]       interfaces =  ClassOrInterfaceType.EMPTY;
		CParseClassContext context = CParseClassContext.getInstance();
		TokenReference     sourceRef = buildTokenReference();
		
		
		match(LITERAL_interface);
		ident = LT(1);
		match(IDENT);
		interfaces=jInterfaceExtends();
		jClassBlock(context);
		if ( inputState.guessing==0 ) {
			
			self = new JInterfaceDeclaration(sourceRef,
			mods, ident.getText(),
			interfaces,
			context.getFields(),
			context.getMethods(),
			context.getInnerClasses(),
			context.getBody(),
			getJavadocComment(),
			getStatementComment());
			context.release();
			
		}
		return self;
	}
	
/**
 * A declaration is the creation of a reference or primitive-type variable
 *  Create a separate Type/Var tree for each var in the var list.
 */
	public final JVariableDeclarationStatement  jDeclaration(
		
	) throws RecognitionException, TokenStreamException {
		JVariableDeclarationStatement self = null;
		
		
		int mods;
		Type type;
		JVariableDefinition[] decl;
		TokenReference sourceRef = buildTokenReference();
		
		
		mods=jModifiers();
		type=jTypeSpec();
		decl=jVariableDefinitions(mods, type);
		if ( inputState.guessing==0 ) {
			
			self = new JVariableDeclarationStatement(sourceRef, 
			decl,
			getStatementComment());
			
		}
		return self;
	}
	
	public final Type  jTypeSpec(
		
	) throws RecognitionException, TokenStreamException {
		Type self = null;
		
		
		switch ( LA(1)) {
		case IDENT:
		{
			self=jClassTypeSpec();
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		{
			self=jBuiltInTypeSpec();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final JVariableDefinition[]  jVariableDefinitions(
		int mods, Type type
	) throws RecognitionException, TokenStreamException {
		JVariableDefinition[] self = null;
		
		
		List vars = new ArrayList(10);
		JVariableDefinition decl;
		
		
		decl=jVariableDeclarator(mods, type);
		if ( inputState.guessing==0 ) {
			vars.add(decl);
		}
		{
		_loop52:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				decl=jVariableDeclarator(mods, type);
				if ( inputState.guessing==0 ) {
					vars.add(decl);
				}
			}
			else {
				break _loop52;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (JVariableDefinition[])
			vars.toArray(new JVariableDefinition[vars.size()]);
			
		}
		return self;
	}
	
	public final int  jModifier(
		
	) throws RecognitionException, TokenStreamException {
		int self = 0;
		
		
		switch ( LA(1)) {
		case LITERAL_public:
		{
			match(LITERAL_public);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_PUBLIC;
			}
			break;
		}
		case LITERAL_protected:
		{
			match(LITERAL_protected);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_PROTECTED;
			}
			break;
		}
		case LITERAL_private:
		{
			match(LITERAL_private);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_PRIVATE;
			}
			break;
		}
		case LITERAL_static:
		{
			match(LITERAL_static);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_STATIC;
			}
			break;
		}
		case LITERAL_abstract:
		{
			match(LITERAL_abstract);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_ABSTRACT;
			}
			break;
		}
		case LITERAL_final:
		{
			match(LITERAL_final);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_FINAL;
			}
			break;
		}
		case LITERAL_native:
		{
			match(LITERAL_native);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_NATIVE;
			}
			break;
		}
		case LITERAL_synchronized:
		{
			match(LITERAL_synchronized);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_SYNCHRONIZED;
			}
			break;
		}
		case LITERAL_strictfp:
		{
			match(LITERAL_strictfp);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_STRICT;
			}
			break;
		}
		case LITERAL_transient:
		{
			match(LITERAL_transient);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_TRANSIENT;
			}
			break;
		}
		case LITERAL_volatile:
		{
			match(LITERAL_volatile);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_VOLATILE;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final ReferenceType  jClassTypeSpec(
		
	) throws RecognitionException, TokenStreamException {
		ReferenceType self = null;
		
		
		String name = null;
		int bounds = 0;
		
		
		name=jIdentifier();
		if ( inputState.guessing==0 ) {
			self = ClassOrInterfaceType.lookup(name);
		}
		{
		_loop21:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop21;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
			self = new ArrayType(self, bounds);
			}
			
		}
		return self;
	}
	
	public final Type  jBuiltInTypeSpec(
		
	) throws RecognitionException, TokenStreamException {
		Type self = null;
		
		
		int bounds = 0;
		
		
		self=jBuiltInType();
		{
		_loop24:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop24;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
			self = new ArrayType(self, bounds);
			}
			
		}
		return self;
	}
	
	public final Type  jBuiltInType(
		
	) throws RecognitionException, TokenStreamException {
		Type self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_boolean:
		{
			match(LITERAL_boolean);
			if ( inputState.guessing==0 ) {
				self = StandardType.BOOLEAN;
			}
			break;
		}
		case LITERAL_byte:
		{
			match(LITERAL_byte);
			if ( inputState.guessing==0 ) {
				self = StandardType.BYTE;
			}
			break;
		}
		case LITERAL_char:
		{
			match(LITERAL_char);
			if ( inputState.guessing==0 ) {
				self = StandardType.CHAR;
			}
			break;
		}
		case LITERAL_double:
		{
			match(LITERAL_double);
			if ( inputState.guessing==0 ) {
				self = StandardType.DOUBLE;
			}
			break;
		}
		case LITERAL_float:
		{
			match(LITERAL_float);
			if ( inputState.guessing==0 ) {
				self = StandardType.FLOAT;
			}
			break;
		}
		case LITERAL_int:
		{
			match(LITERAL_int);
			if ( inputState.guessing==0 ) {
				self = StandardType.INTEGER;
			}
			break;
		}
		case LITERAL_long:
		{
			match(LITERAL_long);
			if ( inputState.guessing==0 ) {
				self = StandardType.LONG;
			}
			break;
		}
		case LITERAL_short:
		{
			match(LITERAL_short);
			if ( inputState.guessing==0 ) {
				self = StandardType.SHORT;
			}
			break;
		}
		case LITERAL_void:
		{
			match(LITERAL_void);
			if ( inputState.guessing==0 ) {
				self = StandardType.VOID;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final Type  jType(
		
	) throws RecognitionException, TokenStreamException {
		Type type = null;
		
		
		String name;
		
		
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		{
			type=jBuiltInType();
			break;
		}
		case IDENT:
		{
			name=jIdentifier();
			if ( inputState.guessing==0 ) {
				type = ClassOrInterfaceType.lookup(name);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return type;
	}
	
	public final String  jSuperClassClause(
		
	) throws RecognitionException, TokenStreamException {
		String self = null;
		
		
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			match(LITERAL_extends);
			self=jIdentifier();
			break;
		}
		case LCURLY:
		case LITERAL_implements:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final ClassOrInterfaceType[]  jImplementsClause(
		
	) throws RecognitionException, TokenStreamException {
		ClassOrInterfaceType[] self = ClassOrInterfaceType.EMPTY;
		
		
		{
		switch ( LA(1)) {
		case LITERAL_implements:
		{
			match(LITERAL_implements);
			self=jNameList();
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final void jClassBlock(
		CParseClassContext context
	) throws RecognitionException, TokenStreamException {
		
		
		match(LCURLY);
		{
		_loop37:
		do {
			switch ( LA(1)) {
			case IDENT:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_double:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_long:
			case LITERAL_short:
			case LITERAL_void:
			case LITERAL_public:
			case LITERAL_protected:
			case LITERAL_private:
			case LITERAL_static:
			case LITERAL_abstract:
			case LITERAL_final:
			case LITERAL_native:
			case LITERAL_synchronized:
			case LITERAL_strictfp:
			case LITERAL_transient:
			case LITERAL_volatile:
			case LITERAL_class:
			case LITERAL_interface:
			case LCURLY:
			{
				jMember(context);
				break;
			}
			case SEMI:
			{
				match(SEMI);
				if ( inputState.guessing==0 ) {
					reportTrouble(new CWarning(buildTokenReference(),
					KjcMessages.STRAY_SEMICOLON, null));
				}
				break;
			}
			default:
			{
				break _loop37;
			}
			}
		} while (true);
		}
		match(RCURLY);
	}
	
	public final ClassOrInterfaceType[]  jInterfaceExtends(
		
	) throws RecognitionException, TokenStreamException {
		ClassOrInterfaceType[] self = ClassOrInterfaceType.EMPTY;
		
		
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			match(LITERAL_extends);
			self=jNameList();
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final void jMember(
		CParseClassContext context
	) throws RecognitionException, TokenStreamException {
		
		Token  ctor = null;
		Token  ident = null;
		
		int mods = 0;
		JStatement[] body = null;
		JTypeDeclaration decl;
		Type type;
		JFormalParameter[] params;
		int bounds = 0;
		ClassOrInterfaceType[] throwsList = ClassOrInterfaceType.EMPTY;
		JVariableDefinition[] vars;
		TokenReference sourceRef = buildTokenReference();
		
		
		if ((_tokenSet_1.member(LA(1))) && (_tokenSet_2.member(LA(2)))) {
			mods=jModifiers();
			{
			switch ( LA(1)) {
			case LITERAL_class:
			{
				decl=jClassDefinition(mods);
				if ( inputState.guessing==0 ) {
					
					context.addInnerDeclaration(decl);
					
				}
				break;
			}
			case LITERAL_interface:
			{
				decl=jInterfaceDefinition(mods);
				if ( inputState.guessing==0 ) {
					
					context.addInnerDeclaration(decl);
					
				}
				break;
			}
			default:
				if ((LA(1)==IDENT) && (LA(2)==LPAREN)) {
					ctor = LT(1);
					match(IDENT);
					match(LPAREN);
					params=jParameterDeclarationList(JLocalVariable.DES_PARAMETER);
					match(RPAREN);
					{
					switch ( LA(1)) {
					case LITERAL_throws:
					{
						throwsList=jThrowsClause();
						break;
					}
					case LCURLY:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					body=jCompoundStatement();
					if ( inputState.guessing==0 ) {
						
						context.addMethodDeclaration
						(new JConstructorDeclaration(sourceRef,
						mods,
						ctor.getText(),
						params,
						throwsList,
						new JConstructorBlock(sourceRef,
						body),
						getJavadocComment(),
						getStatementComment()));
						
					}
				}
				else if ((_tokenSet_3.member(LA(1))) && (_tokenSet_4.member(LA(2)))) {
					type=jTypeSpec();
					{
					if ((LA(1)==IDENT) && (LA(2)==LPAREN)) {
						ident = LT(1);
						match(IDENT);
						match(LPAREN);
						params=jParameterDeclarationList(JLocalVariable.DES_PARAMETER);
						match(RPAREN);
						{
						_loop47:
						do {
							if ((LA(1)==LBRACK)) {
								match(LBRACK);
								match(RBRACK);
								if ( inputState.guessing==0 ) {
									bounds += 1;
								}
							}
							else {
								break _loop47;
							}
							
						} while (true);
						}
						if ( inputState.guessing==0 ) {
							
							if (bounds > 0) {
							reportTrouble
							(new CWarning(sourceRef,
							KjcMessages.OLD_STYLE_ARRAY_BOUNDS,
							null));
							type = new ArrayType(type, bounds);
							}
							
						}
						{
						switch ( LA(1)) {
						case LITERAL_throws:
						{
							throwsList=jThrowsClause();
							break;
						}
						case SEMI:
						case LCURLY:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						{
						switch ( LA(1)) {
						case LCURLY:
						{
							body=jCompoundStatement();
							break;
						}
						case SEMI:
						{
							match(SEMI);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							
							context.addMethodDeclaration
							(new JMethodDeclaration
							(sourceRef, mods, type, ident.getText(), params,
							throwsList,
							( body == null ? null
							: new JBlock(sourceRef, body, null)),
							getJavadocComment(),
							getStatementComment()));
							
						}
					}
					else if ((LA(1)==IDENT) && (_tokenSet_5.member(LA(2)))) {
						vars=jVariableDefinitions(mods, type);
						match(SEMI);
						if ( inputState.guessing==0 ) {
							
							for (int i = 0; i < vars.length; i++) {
							context.addFieldDeclaration
							(new JFieldDeclaration(sourceRef,
							vars[i], 
							getJavadocComment(),
							getStatementComment())); 
							}
							
						}
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		else if ((LA(1)==LITERAL_static) && (LA(2)==LCURLY)) {
			match(LITERAL_static);
			body=jCompoundStatement();
			if ( inputState.guessing==0 ) {
				
				context.addBlockInitializer(new JClassBlock(sourceRef, true, body));
				
			}
		}
		else if ((LA(1)==LCURLY)) {
			body=jCompoundStatement();
			if ( inputState.guessing==0 ) {
				
				context.addBlockInitializer(new JClassBlock(sourceRef, false, body));
				
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
	}
	
	public final ClassOrInterfaceType[]  jNameList(
		
	) throws RecognitionException, TokenStreamException {
		ClassOrInterfaceType[] self = null;
		
		
		String        name;
		List        list = new ArrayList(10);
		
		
		name=jIdentifier();
		if ( inputState.guessing==0 ) {
			list.add(ClassOrInterfaceType.lookup(name));
		}
		{
		_loop194:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				name=jIdentifier();
				if ( inputState.guessing==0 ) {
					list.add(ClassOrInterfaceType.lookup(name));
				}
			}
			else {
				break _loop194;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (ClassOrInterfaceType[])list.toArray(new ClassOrInterfaceType[list.size()]);
			
		}
		return self;
	}
	
	public final JFormalParameter[]  jParameterDeclarationList(
		int desc
	) throws RecognitionException, TokenStreamException {
		JFormalParameter[] self = JFormalParameter.EMPTY;
		
		
		JFormalParameter              elem = null;
		List                        list = new ArrayList(10);
		
		
		{
		switch ( LA(1)) {
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LITERAL_final:
		{
			elem=jParameterDeclaration(desc);
			if ( inputState.guessing==0 ) {
				list.add(elem);
			}
			{
			_loop69:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					elem=jParameterDeclaration(desc);
					if ( inputState.guessing==0 ) {
						list.add(elem);
					}
				}
				else {
					break _loop69;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
				self = (JFormalParameter[])list.toArray(new JFormalParameter[list.size()]); 
				
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final ClassOrInterfaceType[]  jThrowsClause(
		
	) throws RecognitionException, TokenStreamException {
		ClassOrInterfaceType[] self;
		
		
		match(LITERAL_throws);
		self=jNameList();
		return self;
	}
	
	public final JStatement[]  jCompoundStatement(
		
	) throws RecognitionException, TokenStreamException {
		JStatement[] self = null;
		
		
		List                body = new ArrayList(100);
		JStatement            stmt;
		
		
		match(LCURLY);
		{
		_loop76:
		do {
			if ((_tokenSet_6.member(LA(1)))) {
				stmt=jStatement();
				if ( inputState.guessing==0 ) {
					
					if (stmt instanceof JEmptyStatement) {
					reportTrouble(new CWarning(stmt.getTokenReference(),
					KjcMessages.STRAY_SEMICOLON, null));
					}
					body.add(stmt);
				}
			}
			else {
				break _loop76;
			}
			
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self = (JStatement[])body.toArray(new JStatement[body.size()]);
			
		}
		return self;
	}
	
/**
 * Declaration of a variable.  This can be a class/instance variable,
 * or a local variable in a method.
 * It can also include possible initialization.
 */
	public final JVariableDefinition  jVariableDeclarator(
		int mods, Type type
	) throws RecognitionException, TokenStreamException {
		JVariableDefinition self = null;
		
		Token  ident = null;
		
		int            bounds = 0;
		JExpression    expr = null;
		TokenReference sourceRef = buildTokenReference();
		
		
		ident = LT(1);
		match(IDENT);
		{
		_loop55:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop55;
			}
			
		} while (true);
		}
		expr=jVarInitializer();
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
			reportTrouble(new CWarning(sourceRef,
			KjcMessages.OLD_STYLE_ARRAY_BOUNDS,
			null));
			type = new ArrayType(type, bounds);
			}
			self = new JVariableDefinition(sourceRef, mods, type, ident.getText(),
			expr);
			
		}
		return self;
	}
	
	public final JExpression  jVarInitializer(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		{
		switch ( LA(1)) {
		case ASSIGN:
		{
			match(ASSIGN);
			self=jInitializer();
			break;
		}
		case SEMI:
		case COMMA:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression  jInitializer(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		switch ( LA(1)) {
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			self=jExpression();
			break;
		}
		case LCURLY:
		{
			self=jArrayInitializer();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final JArrayInitializer  jArrayInitializer(
		
	) throws RecognitionException, TokenStreamException {
		JArrayInitializer self = null;
		
		
		List list = new ArrayList(10);
		JExpression    expr = null;
		TokenReference sourceRef = buildTokenReference();
		
		
		match(LCURLY);
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			break;
		}
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LCURLY:
		case RCURLY:
		case LPAREN:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			{
			switch ( LA(1)) {
			case IDENT:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_double:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_long:
			case LITERAL_short:
			case LITERAL_void:
			case LCURLY:
			case LPAREN:
			case PLUS:
			case MINUS:
			case INC:
			case DEC:
			case BNOT:
			case LNOT:
			case LITERAL_this:
			case LITERAL_super:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_null:
			case LITERAL_new:
			case INTEGER_LITERAL:
			case CHARACTER_LITERAL:
			case STRING_LITERAL:
			case REAL_LITERAL:
			{
				list=jInitializers(list);
				break;
			}
			case RCURLY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self =
			new JArrayInitializer(sourceRef, (JExpression[])
			list.toArray(new JExpression[list.size()])); 
			
		}
		return self;
	}
	
	public final List  jInitializers(
		List expressions
	) throws RecognitionException, TokenStreamException {
		List newExpressions = expressions;
		
		
		JExpression    initializer = null;
		TokenReference sourceRef = buildTokenReference();
		
		
		initializer=jInitializer();
		if ( inputState.guessing==0 ) {
			
			newExpressions.add(initializer);
			
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			{
			switch ( LA(1)) {
			case IDENT:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_double:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_long:
			case LITERAL_short:
			case LITERAL_void:
			case LCURLY:
			case LPAREN:
			case PLUS:
			case MINUS:
			case INC:
			case DEC:
			case BNOT:
			case LNOT:
			case LITERAL_this:
			case LITERAL_super:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_null:
			case LITERAL_new:
			case INTEGER_LITERAL:
			case CHARACTER_LITERAL:
			case STRING_LITERAL:
			case REAL_LITERAL:
			{
				newExpressions=jInitializers(newExpressions);
				break;
			}
			case RCURLY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case RCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return newExpressions;
	}
	
	public final JExpression  jExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		self=jAssignmentExpression();
		return self;
	}
	
	public final JFormalParameter  jParameterDeclaration(
		int desc
	) throws RecognitionException, TokenStreamException {
		JFormalParameter self = null;
		
		Token  ident = null;
		
		boolean       isFinal = false;
		int           bounds = 0;
		Type         type;
		TokenReference        sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_final:
		{
			match(LITERAL_final);
			if ( inputState.guessing==0 ) {
				isFinal = true;
			}
			break;
		}
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		type=jTypeSpec();
		ident = LT(1);
		match(IDENT);
		{
		_loop73:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop73;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
			reportTrouble(new CWarning(sourceRef, KjcMessages.OLD_STYLE_ARRAY_BOUNDS, null));
			type = new ArrayType(type, bounds);
			}
			self = new JFormalParameter(sourceRef, desc, type, ident.getText(), isFinal);
			
		}
		return self;
	}
	
	public final JStatement  jStatement(
		
	) throws RecognitionException, TokenStreamException {
		JStatement self = null;
		
		
		JExpression           expr;
		JStatement[]          stmts;
		JTypeDeclaration      type;
		JavaStyleComment[]    comments = getStatementComment();
		TokenReference        sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LCURLY:
		{
			stmts=jCompoundStatement();
			if ( inputState.guessing==0 ) {
				self = new JBlock(sourceRef, stmts, comments);
			}
			break;
		}
		case LITERAL_class:
		{
			type=jClassDefinition(0);
			if ( inputState.guessing==0 ) {
				self = new JTypeDeclarationStatement(type.getTokenReference(), type);
			}
			break;
		}
		case LITERAL_if:
		{
			self=jIfStatement();
			break;
		}
		case LITERAL_for:
		{
			self=jForStatement();
			break;
		}
		case LITERAL_while:
		{
			self=jWhileStatement();
			break;
		}
		case LITERAL_do:
		{
			self=jDoStatement();
			break;
		}
		case LITERAL_break:
		{
			self=jBreakStatement();
			break;
		}
		case LITERAL_continue:
		{
			self=jContinueStatement();
			break;
		}
		case LITERAL_return:
		{
			self=jReturnStatement();
			break;
		}
		case LITERAL_switch:
		{
			self=jSwitchStatement();
			break;
		}
		case LITERAL_try:
		{
			self=jTryBlock();
			break;
		}
		case LITERAL_throw:
		{
			self=jThrowStatement();
			break;
		}
		case SEMI:
		{
			match(SEMI);
			if ( inputState.guessing==0 ) {
				self = new JEmptyStatement(sourceRef, comments);
			}
			break;
		}
		default:
			if ((LA(1)==LITERAL_final) && (LA(2)==LITERAL_class)) {
				match(LITERAL_final);
				type=jClassDefinition(at.dms.kjc.Constants.ACC_FINAL);
				if ( inputState.guessing==0 ) {
					self = new JTypeDeclarationStatement(type.getTokenReference(), type);
				}
			}
			else if ((LA(1)==LITERAL_abstract) && (LA(2)==LITERAL_class)) {
				match(LITERAL_abstract);
				type=jClassDefinition(at.dms.kjc.Constants.ACC_ABSTRACT);
				if ( inputState.guessing==0 ) {
					self = new JTypeDeclarationStatement(type.getTokenReference(), type);
				}
			}
			else {
				boolean synPredMatched79 = false;
				if (((_tokenSet_7.member(LA(1))) && (_tokenSet_8.member(LA(2))))) {
					int _m79 = mark();
					synPredMatched79 = true;
					inputState.guessing++;
					try {
						{
						jModifiers();
						jTypeSpec();
						match(IDENT);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched79 = false;
					}
					rewind(_m79);
					inputState.guessing--;
				}
				if ( synPredMatched79 ) {
					self=jDeclaration();
					match(SEMI);
				}
				else if ((_tokenSet_9.member(LA(1))) && (_tokenSet_10.member(LA(2)))) {
					expr=jExpression();
					match(SEMI);
					if ( inputState.guessing==0 ) {
						self = new JExpressionStatement(sourceRef, expr, comments);
					}
				}
				else if ((LA(1)==IDENT) && (LA(2)==COLON)) {
					self=jLabeledStatement();
				}
				else if ((LA(1)==LITERAL_synchronized) && (LA(2)==LPAREN)) {
					self=jSynchronizedStatement();
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}}
			return self;
		}
		
	public final JLabeledStatement  jLabeledStatement(
		
	) throws RecognitionException, TokenStreamException {
		JLabeledStatement self = null;
		
		Token  label = null;
		
		JStatement            stmt;
		TokenReference        sourceRef = buildTokenReference();
		
		
		label = LT(1);
		match(IDENT);
		match(COLON);
		stmt=jStatement();
		if ( inputState.guessing==0 ) {
			
			if (stmt instanceof JEmptyStatement) {
			reportTrouble(new CWarning(sourceRef,
			KjcMessages.STRAY_SEMICOLON, null));
			}
			if (stmt instanceof JVariableDeclarationStatement) {
			reportTrouble(new PositionedError(sourceRef,
			KjcMessages.LABEL_NOT_STATEMENT,
			null));
			}
			self = new JLabeledStatement(sourceRef, label.getText(),
			stmt, getStatementComment());
			
		}
		return self;
	}
	
	public final JIfStatement  jIfStatement(
		
	) throws RecognitionException, TokenStreamException {
		JIfStatement self = null;
		
		
		JExpression           cond;
		JStatement            thenClause;
		JStatement            elseClause = null;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_if);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		thenClause=jStatement();
		{
		if ((LA(1)==LITERAL_else) && (_tokenSet_6.member(LA(2)))) {
			match(LITERAL_else);
			elseClause=jStatement();
		}
		else if ((_tokenSet_11.member(LA(1))) && (_tokenSet_12.member(LA(2)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		if ( inputState.guessing==0 ) {
			
			if (! (thenClause instanceof JBlock)) {
			reportTrouble(new CWarning(sourceRef, KjcMessages.ENCLOSE_IF_THEN_IN_BLOCK, null));
			}
			if (elseClause != null && !(elseClause instanceof JBlock || elseClause instanceof JIfStatement)) {
			reportTrouble(new CWarning(sourceRef, KjcMessages.ENCLOSE_IF_ELSE_IN_BLOCK, null));
			}
			self = new JIfStatement(sourceRef, cond, thenClause, elseClause, getStatementComment());
			
		}
		return self;
	}
	
	public final JForStatement  jForStatement(
		
	) throws RecognitionException, TokenStreamException {
		JForStatement self = null;
		
		
		JStatement            init;
		JExpression           cond;
		JStatement            iter;
		JStatement            body;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_for);
		match(LPAREN);
		init=jForInit();
		match(SEMI);
		cond=jForCond();
		match(SEMI);
		iter=jForIter();
		match(RPAREN);
		body=jStatement();
		if ( inputState.guessing==0 ) {
			
			if (!(body instanceof JBlock || body instanceof JEmptyStatement)) {
			reportTrouble(new CWarning(sourceRef, KjcMessages.ENCLOSE_LOOP_BODY_IN_BLOCK, null));
			}
			self = new JForStatement(sourceRef, init, cond, iter, body, getStatementComment());
			
		}
		return self;
	}
	
	public final JWhileStatement  jWhileStatement(
		
	) throws RecognitionException, TokenStreamException {
		JWhileStatement self = null;
		
		
		JExpression           cond;
		JStatement            body;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_while);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		body=jStatement();
		if ( inputState.guessing==0 ) {
			
			if (!(body instanceof JBlock || body instanceof JEmptyStatement)) {
			reportTrouble(new CWarning(sourceRef, KjcMessages.ENCLOSE_LOOP_BODY_IN_BLOCK, null));
			}
			self = new JWhileStatement(sourceRef, cond, body, getStatementComment());
			
		}
		return self;
	}
	
	public final JDoStatement  jDoStatement(
		
	) throws RecognitionException, TokenStreamException {
		JDoStatement self = null;
		
		
		JExpression           cond;
		JStatement            body;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_do);
		body=jStatement();
		match(LITERAL_while);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		match(SEMI);
		if ( inputState.guessing==0 ) {
			
			if (! (body instanceof JBlock)) {
			reportTrouble(new CWarning(sourceRef, KjcMessages.ENCLOSE_LOOP_BODY_IN_BLOCK, null));
			}
			self = new JDoStatement(sourceRef, cond, body, getStatementComment());
			
		}
		return self;
	}
	
	public final JBreakStatement  jBreakStatement(
		
	) throws RecognitionException, TokenStreamException {
		JBreakStatement self = null;
		
		Token  label = null;
		
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_break);
		{
		switch ( LA(1)) {
		case IDENT:
		{
			label = LT(1);
			match(IDENT);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JBreakStatement(sourceRef, label == null ? null : label.getText(), getStatementComment());
		}
		return self;
	}
	
	public final JContinueStatement  jContinueStatement(
		
	) throws RecognitionException, TokenStreamException {
		JContinueStatement self = null;
		
		Token  label = null;
		
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_continue);
		{
		switch ( LA(1)) {
		case IDENT:
		{
			label = LT(1);
			match(IDENT);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JContinueStatement(sourceRef, label == null ? null : label.getText(), getStatementComment());
		}
		return self;
	}
	
	public final JReturnStatement  jReturnStatement(
		
	) throws RecognitionException, TokenStreamException {
		JReturnStatement self = null;
		
		
		JExpression           expr = null;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_return);
		{
		switch ( LA(1)) {
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			expr=jExpression();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JReturnStatement(sourceRef, expr, getStatementComment());
		}
		return self;
	}
	
	public final JSwitchStatement  jSwitchStatement(
		
	) throws RecognitionException, TokenStreamException {
		JSwitchStatement self = null;
		
		
		JExpression           expr = null;
		List                body = null;
		JSwitchGroup          group;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_switch);
		match(LPAREN);
		expr=jExpression();
		match(RPAREN);
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			body = new ArrayList(10);
		}
		{
		_loop95:
		do {
			if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default)) {
				group=jCasesGroup();
				if ( inputState.guessing==0 ) {
					body.add(group);
				}
			}
			else {
				break _loop95;
			}
			
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self =
			new JSwitchStatement(sourceRef,
			expr, 
			(JSwitchGroup[])
			body.toArray(new JSwitchGroup[body.size()]),
			getStatementComment());
			
		}
		return self;
	}
	
	public final JStatement  jTryBlock(
		
	) throws RecognitionException, TokenStreamException {
		JStatement self = null;
		
		
		JBlock                tryClause = null;
		JStatement[]          compound;
		List                catchClauses = new ArrayList(10);
		JBlock                finallyClause = null;
		JCatchClause          catcher = null;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_try);
		compound=jCompoundStatement();
		if ( inputState.guessing==0 ) {
			tryClause = new JBlock(sourceRef, compound, null);
		}
		{
		_loop114:
		do {
			if ((LA(1)==LITERAL_catch)) {
				catcher=jCatchHandler();
				if ( inputState.guessing==0 ) {
					catchClauses.add(catcher);
				}
			}
			else {
				break _loop114;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case LITERAL_finally:
		{
			match(LITERAL_finally);
			compound=jCompoundStatement();
			if ( inputState.guessing==0 ) {
				finallyClause = new JBlock(sourceRef, compound, null);
			}
			break;
		}
		case SEMI:
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LITERAL_public:
		case LITERAL_protected:
		case LITERAL_private:
		case LITERAL_static:
		case LITERAL_abstract:
		case LITERAL_final:
		case LITERAL_native:
		case LITERAL_synchronized:
		case LITERAL_strictfp:
		case LITERAL_transient:
		case LITERAL_volatile:
		case LITERAL_class:
		case LCURLY:
		case RCURLY:
		case LPAREN:
		case LITERAL_if:
		case LITERAL_else:
		case LITERAL_while:
		case LITERAL_do:
		case LITERAL_break:
		case LITERAL_continue:
		case LITERAL_return:
		case LITERAL_throw:
		case LITERAL_switch:
		case LITERAL_case:
		case LITERAL_default:
		case LITERAL_for:
		case LITERAL_try:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			if (catchClauses.size() > 0) {
			self = new JTryCatchStatement(sourceRef,
			tryClause,
			(JCatchClause[])catchClauses.toArray(new JCatchClause[catchClauses.size()]),
			finallyClause == null ? getStatementComment() : null);
			}
			if (finallyClause != null) {
			// If both catch and finally clauses are present,
			// the try-catch is embedded as try clause into a
			// try-finally statement.
			if (self != null) {
			tryClause = new JBlock(sourceRef, new JStatement[] {self}, null);
			}
			self = new JTryFinallyStatement(sourceRef, tryClause, finallyClause, getStatementComment());
			}
			
			if (self == null) {
			// try without catch or finally: error
			reportTrouble(new PositionedError(sourceRef, KjcMessages.TRY_NOCATCH, null));
			self = tryClause;
			}
			
		}
		return self;
	}
	
	public final JThrowStatement  jThrowStatement(
		
	) throws RecognitionException, TokenStreamException {
		JThrowStatement self = null;
		
		
		JExpression           expr;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_throw);
		expr=jExpression();
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JThrowStatement(sourceRef, expr, getStatementComment());
		}
		return self;
	}
	
	public final JSynchronizedStatement  jSynchronizedStatement(
		
	) throws RecognitionException, TokenStreamException {
		JSynchronizedStatement self = null;
		
		
		JExpression           expr;
		JStatement[]          body;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_synchronized);
		match(LPAREN);
		expr=jExpression();
		match(RPAREN);
		body=jCompoundStatement();
		if ( inputState.guessing==0 ) {
			
			self = new JSynchronizedStatement(sourceRef,
			expr, 
			new JBlock(sourceRef, body, null),
			getStatementComment());
			
		}
		return self;
	}
	
	public final JSwitchGroup  jCasesGroup(
		
	) throws RecognitionException, TokenStreamException {
		JSwitchGroup self = null;
		
		
		List labels = new ArrayList(10);
		List stmts = new ArrayList(10);
		
		JSwitchLabel          label;
		JStatement            stmt;
		TokenReference        sourceRef = buildTokenReference();
		
		
		{
		int _cnt98=0;
		_loop98:
		do {
			if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default) && (_tokenSet_13.member(LA(2)))) {
				label=jACase();
				if ( inputState.guessing==0 ) {
					labels.add(label);
				}
			}
			else {
				if ( _cnt98>=1 ) { break _loop98; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt98++;
		} while (true);
		}
		{
		_loop100:
		do {
			if ((_tokenSet_6.member(LA(1)))) {
				stmt=jStatement();
				if ( inputState.guessing==0 ) {
					
					if (stmt instanceof JEmptyStatement) {
					reportTrouble(new CWarning(stmt.getTokenReference(),
					KjcMessages.STRAY_SEMICOLON, null));
					}
					stmts.add(stmt);
					
				}
			}
			else {
				break _loop100;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self =
			new JSwitchGroup(sourceRef,
			(JSwitchLabel[])
			labels.toArray(new JSwitchLabel[labels.size()]), 
			(JStatement[])
			stmts.toArray(new JStatement[stmts.size()]));
			
		}
		return self;
	}
	
	public final JSwitchLabel  jACase(
		
	) throws RecognitionException, TokenStreamException {
		JSwitchLabel self = null;
		
		
		JExpression           expr = null;
		TokenReference        sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_case:
		{
			match(LITERAL_case);
			expr=jExpression();
			if ( inputState.guessing==0 ) {
				self = new JSwitchLabel(sourceRef, expr);
			}
			break;
		}
		case LITERAL_default:
		{
			match(LITERAL_default);
			if ( inputState.guessing==0 ) {
				self = new JSwitchLabel(sourceRef, null);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(COLON);
		return self;
	}
	
	public final JStatement  jForInit(
		
	) throws RecognitionException, TokenStreamException {
		JStatement self = null;
		
		
		JExpression[] list;
		
		
		{
		boolean synPredMatched107 = false;
		if (((_tokenSet_7.member(LA(1))) && (_tokenSet_8.member(LA(2))))) {
			int _m107 = mark();
			synPredMatched107 = true;
			inputState.guessing++;
			try {
				{
				jDeclaration();
				}
			}
			catch (RecognitionException pe) {
				synPredMatched107 = false;
			}
			rewind(_m107);
			inputState.guessing--;
		}
		if ( synPredMatched107 ) {
			self=jDeclaration();
		}
		else if ((_tokenSet_9.member(LA(1))) && (_tokenSet_14.member(LA(2)))) {
			list=jExpressionList();
			if ( inputState.guessing==0 ) {
				self = new JExpressionListStatement(buildTokenReference(), list, getStatementComment());
			}
		}
		else if ((LA(1)==SEMI)) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		return self;
	}
	
	public final JExpression  jForCond(
		
	) throws RecognitionException, TokenStreamException {
		JExpression expr = null;
		
		
		{
		switch ( LA(1)) {
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			expr=jExpression();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return expr;
	}
	
	public final JExpressionListStatement  jForIter(
		
	) throws RecognitionException, TokenStreamException {
		JExpressionListStatement self = null;
		
		
		JExpression[] list;
		
		
		{
		switch ( LA(1)) {
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			list=jExpressionList();
			if ( inputState.guessing==0 ) {
				self = new JExpressionListStatement(buildTokenReference(), list, null);
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression[]  jExpressionList(
		
	) throws RecognitionException, TokenStreamException {
		JExpression[] self = null;
		
		
		JExpression expr;
		List list = new ArrayList(10);
		
		
		expr=jExpression();
		if ( inputState.guessing==0 ) {
			list.add(expr);
		}
		{
		_loop120:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				expr=jExpression();
				if ( inputState.guessing==0 ) {
					list.add(expr);
				}
			}
			else {
				break _loop120;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (JExpression[])list.toArray(new JExpression[list.size()]);
			
		}
		return self;
	}
	
	public final JCatchClause  jCatchHandler(
		
	) throws RecognitionException, TokenStreamException {
		JCatchClause self = null;
		
		
		JFormalParameter      param;
		JStatement[]          body;
		TokenReference        sourceRef = buildTokenReference();
		
		
		match(LITERAL_catch);
		match(LPAREN);
		param=jParameterDeclaration(JLocalVariable.DES_CATCH_PARAMETER);
		match(RPAREN);
		body=jCompoundStatement();
		if ( inputState.guessing==0 ) {
			
			self = new JCatchClause(sourceRef, param,
			new JBlock(sourceRef, body, null)); 
			
		}
		return self;
	}
	
	public final JExpression  jAssignmentExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		int oper = -1;
		JExpression right;
		
		
		self=jConditionalExpression();
		{
		switch ( LA(1)) {
		case ASSIGN:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case SLASH_ASSIGN:
		case PERCENT_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		{
			{
			switch ( LA(1)) {
			case ASSIGN:
			{
				match(ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_SIMPLE;
				}
				break;
			}
			case PLUS_ASSIGN:
			{
				match(PLUS_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_PLUS;
				}
				break;
			}
			case MINUS_ASSIGN:
			{
				match(MINUS_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_MINUS;
				}
				break;
			}
			case STAR_ASSIGN:
			{
				match(STAR_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_STAR;
				}
				break;
			}
			case SLASH_ASSIGN:
			{
				match(SLASH_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_SLASH;
				}
				break;
			}
			case PERCENT_ASSIGN:
			{
				match(PERCENT_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_PERCENT;
				}
				break;
			}
			case SR_ASSIGN:
			{
				match(SR_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_SR;
				}
				break;
			}
			case BSR_ASSIGN:
			{
				match(BSR_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_BSR;
				}
				break;
			}
			case SL_ASSIGN:
			{
				match(SL_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_SL;
				}
				break;
			}
			case BAND_ASSIGN:
			{
				match(BAND_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_BAND;
				}
				break;
			}
			case BXOR_ASSIGN:
			{
				match(BXOR_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_BXOR;
				}
				break;
			}
			case BOR_ASSIGN:
			{
				match(BOR_ASSIGN);
				if ( inputState.guessing==0 ) {
					oper = Constants.OPE_BOR;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			right=jAssignmentExpression();
			if ( inputState.guessing==0 ) {
				
				self = JAssignmentExpression.create(self.getTokenReference(),
				oper, self, right);
				
			}
			break;
		}
		case SEMI:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case COMMA:
		case COLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression  jConditionalExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           middle;
		JExpression           right;
		
		
		self=jLogicalOrExpression();
		{
		switch ( LA(1)) {
		case QUESTION:
		{
			match(QUESTION);
			middle=jConditionalExpression();
			match(COLON);
			right=jConditionalExpression();
			if ( inputState.guessing==0 ) {
				self = new JConditionalExpression(self.getTokenReference(), self, middle, right);
			}
			break;
		}
		case SEMI:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case COMMA:
		case ASSIGN:
		case COLON:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case SLASH_ASSIGN:
		case PERCENT_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression  jLogicalOrExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           right;
		
		
		self=jLogicalAndExpression();
		{
		_loop128:
		do {
			if ((LA(1)==LOR)) {
				match(LOR);
				right=jLogicalAndExpression();
				if ( inputState.guessing==0 ) {
					self = new JConditionalOrExpression(self.getTokenReference(), self, right);
				}
			}
			else {
				break _loop128;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jLogicalAndExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           right;
		
		
		self=jInclusiveOrExpression();
		{
		_loop131:
		do {
			if ((LA(1)==LAND)) {
				match(LAND);
				right=jInclusiveOrExpression();
				if ( inputState.guessing==0 ) {
					self = new JConditionalAndExpression(self.getTokenReference(), self, right);
				}
			}
			else {
				break _loop131;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jInclusiveOrExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           right;
		
		
		self=jExclusiveOrExpression();
		{
		_loop134:
		do {
			if ((LA(1)==BOR)) {
				match(BOR);
				right=jExclusiveOrExpression();
				if ( inputState.guessing==0 ) {
					self = new JBitwiseExpression(self.getTokenReference(), Constants.OPE_BOR, self, right);
				}
			}
			else {
				break _loop134;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jExclusiveOrExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           right;
		
		
		self=jAndExpression();
		{
		_loop137:
		do {
			if ((LA(1)==BXOR)) {
				match(BXOR);
				right=jAndExpression();
				if ( inputState.guessing==0 ) {
					self = new JBitwiseExpression(self.getTokenReference(), Constants.OPE_BXOR, self, right);
				}
			}
			else {
				break _loop137;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jAndExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           right;
		
		
		self=jEqualityExpression();
		{
		_loop140:
		do {
			if ((LA(1)==BAND)) {
				match(BAND);
				right=jEqualityExpression();
				if ( inputState.guessing==0 ) {
					self = new JBitwiseExpression(self.getTokenReference(), Constants.OPE_BAND, self, right);
				}
			}
			else {
				break _loop140;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jEqualityExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		int                   operator = -1;
		JExpression           right;
		
		
		self=jRelationalExpression();
		{
		_loop144:
		do {
			if ((LA(1)==NOT_EQUAL||LA(1)==EQUAL)) {
				{
				switch ( LA(1)) {
				case NOT_EQUAL:
				{
					match(NOT_EQUAL);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_NE;
					}
					break;
				}
				case EQUAL:
				{
					match(EQUAL);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_EQ;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				right=jRelationalExpression();
				if ( inputState.guessing==0 ) {
					self = new JEqualityExpression(self.getTokenReference(), operator, self, right);
				}
			}
			else {
				break _loop144;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jRelationalExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		int                   operator = -1;
		JExpression           right;
		Type                 type;
		
		
		self=jShiftExpression();
		{
		switch ( LA(1)) {
		case SEMI:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case COMMA:
		case ASSIGN:
		case COLON:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case SLASH_ASSIGN:
		case PERCENT_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		case QUESTION:
		case LOR:
		case LAND:
		case BOR:
		case BXOR:
		case BAND:
		case NOT_EQUAL:
		case EQUAL:
		case LT:
		case GT:
		case LE:
		case GE:
		{
			{
			_loop149:
			do {
				if (((LA(1) >= LT && LA(1) <= GE))) {
					{
					switch ( LA(1)) {
					case LT:
					{
						match(LT);
						if ( inputState.guessing==0 ) {
							operator = Constants.OPE_LT;
						}
						break;
					}
					case GT:
					{
						match(GT);
						if ( inputState.guessing==0 ) {
							operator = Constants.OPE_GT;
						}
						break;
					}
					case LE:
					{
						match(LE);
						if ( inputState.guessing==0 ) {
							operator = Constants.OPE_LE;
						}
						break;
					}
					case GE:
					{
						match(GE);
						if ( inputState.guessing==0 ) {
							operator = Constants.OPE_GE;
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					right=jShiftExpression();
					if ( inputState.guessing==0 ) {
						self = new JRelationalExpression(self.getTokenReference(), operator, self, right);
					}
				}
				else {
					break _loop149;
				}
				
			} while (true);
			}
			break;
		}
		case LITERAL_instanceof:
		{
			match(LITERAL_instanceof);
			type=jTypeSpec();
			if ( inputState.guessing==0 ) {
				self = new JInstanceofExpression(self.getTokenReference(), self, type);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression  jShiftExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		int                   operator = -1;
		JExpression           right;
		
		
		self=jAdditiveExpression();
		{
		_loop153:
		do {
			if (((LA(1) >= SL && LA(1) <= BSR))) {
				{
				switch ( LA(1)) {
				case SL:
				{
					match(SL);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_SL;
					}
					break;
				}
				case SR:
				{
					match(SR);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_SR;
					}
					break;
				}
				case BSR:
				{
					match(BSR);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_BSR;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				right=jAdditiveExpression();
				if ( inputState.guessing==0 ) {
					self = new JShiftExpression(self.getTokenReference(), operator, self, right);
				}
			}
			else {
				break _loop153;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jAdditiveExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		int                   oper = Constants.OPE_PLUS;
		JExpression           right;
		
		
		self=jMultiplicativeExpression();
		{
		_loop157:
		do {
			if ((LA(1)==PLUS||LA(1)==MINUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					match(PLUS);
					if ( inputState.guessing==0 ) {
						oper = Constants.OPE_PLUS;
					}
					break;
				}
				case MINUS:
				{
					match(MINUS);
					if ( inputState.guessing==0 ) {
						oper = Constants.OPE_MINUS;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				right=jMultiplicativeExpression();
				if ( inputState.guessing==0 ) {
					
					if (oper == Constants.OPE_PLUS) {
					self = new JAddExpression(self.getTokenReference(), self, right);
					} else {
					//if (oper == Constants.OPE_MINUS)
					self = new JMinusExpression(self.getTokenReference(), self, right);
					}
					
				}
			}
			else {
				break _loop157;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jMultiplicativeExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		int                   type = 0;
		JExpression           right;
		
		
		self=jUnaryExpression();
		{
		_loop161:
		do {
			if ((_tokenSet_15.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case STAR:
				{
					match(STAR);
					if ( inputState.guessing==0 ) {
						type = 1;
					}
					break;
				}
				case SLASH:
				{
					match(SLASH);
					if ( inputState.guessing==0 ) {
						type = 2;
					}
					break;
				}
				case PERCENT:
				{
					match(PERCENT);
					if ( inputState.guessing==0 ) {
						type = 3;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				right=jUnaryExpression();
				if ( inputState.guessing==0 ) {
					
					if (type == 1) {
					self = new JMultExpression(self.getTokenReference(), self, right);
					} else if (type == 2) {
					self = new JDivideExpression(self.getTokenReference(), self, right);
					} else {
					self = new JModuloExpression(self.getTokenReference(), self, right);
					}
					
				}
			}
			else {
				break _loop161;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jUnaryExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		TokenReference        sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case INC:
		{
			match(INC);
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new JPrefixExpression(sourceRef, Constants.OPE_PREINC, self);
			}
			break;
		}
		case DEC:
		{
			match(DEC);
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new JPrefixExpression(sourceRef, Constants.OPE_PREDEC, self);
			}
			break;
		}
		case MINUS:
		{
			match(MINUS);
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new JUnaryExpression(self.getTokenReference(), Constants.OPE_MINUS, self);
			}
			break;
		}
		case PLUS:
		{
			match(PLUS);
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new JUnaryExpression(self.getTokenReference(), Constants.OPE_PLUS, self);
			}
			break;
		}
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			self=jUnaryExpressionNotPlusMinus();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final JExpression  jUnaryExpressionNotPlusMinus(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		JExpression           expr;
		Type                 dest;
		TokenReference        sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case BNOT:
		{
			match(BNOT);
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				
				self = new JUnaryExpression(self.getTokenReference(),
				Constants.OPE_BNOT, self);
				
			}
			break;
		}
		case LNOT:
		{
			match(LNOT);
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				
				self = new JUnaryExpression(self.getTokenReference(),
				Constants.OPE_LNOT, self);
				
			}
			break;
		}
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			{
			if ((LA(1)==LPAREN) && ((LA(2) >= LITERAL_boolean && LA(2) <= LITERAL_void))) {
				match(LPAREN);
				dest=jBuiltInTypeSpec();
				match(RPAREN);
				expr=jUnaryExpression();
				if ( inputState.guessing==0 ) {
					self = new JCastExpression(sourceRef, expr, dest);
				}
			}
			else {
				boolean synPredMatched166 = false;
				if (((LA(1)==LPAREN) && (LA(2)==IDENT))) {
					int _m166 = mark();
					synPredMatched166 = true;
					inputState.guessing++;
					try {
						{
						match(LPAREN);
						jClassTypeSpec();
						match(RPAREN);
						jUnaryExpressionNotPlusMinus();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched166 = false;
					}
					rewind(_m166);
					inputState.guessing--;
				}
				if ( synPredMatched166 ) {
					match(LPAREN);
					dest=jClassTypeSpec();
					match(RPAREN);
					expr=jUnaryExpressionNotPlusMinus();
					if ( inputState.guessing==0 ) {
						self = new JCastExpression(sourceRef, expr, dest);
					}
				}
				else if ((_tokenSet_16.member(LA(1))) && (_tokenSet_17.member(LA(2)))) {
					self=jPostfixExpression();
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			return self;
		}
		
	public final JExpression  jPostfixExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		Token  ident = null;
		
		int           bounds = 0;
		JExpression   expr;
		JExpression[] args = null;
		Type         type;
		
		
		switch ( LA(1)) {
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			self=jPrimaryExpression();
			{
			_loop172:
			do {
				switch ( LA(1)) {
				case DOT:
				{
					match(DOT);
					{
					switch ( LA(1)) {
					case IDENT:
					{
						ident = LT(1);
						match(IDENT);
						if ( inputState.guessing==0 ) {
							
							self = new JNameExpression(buildTokenReference(),
							self, ident.getText());
							
						}
						break;
					}
					case LITERAL_this:
					{
						match(LITERAL_this);
						if ( inputState.guessing==0 ) {
							
							self = new JThisExpression(buildTokenReference(), self);
							
						}
						break;
					}
					case LITERAL_class:
					{
						match(LITERAL_class);
						if ( inputState.guessing==0 ) {
							
							self = new JClassExpression(buildTokenReference(), self, 0);
							
						}
						break;
					}
					case LITERAL_new:
					{
						self=jQualifiedNewExpression(self);
						break;
					}
					case LITERAL_super:
					{
						match(LITERAL_super);
						if ( inputState.guessing==0 ) {
							
							self = new JSuperExpression(buildTokenReference(), self);
							
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case LPAREN:
				{
					match(LPAREN);
					args=jArgList();
					match(RPAREN);
					if ( inputState.guessing==0 ) {
						
						if (self instanceof JSuperExpression) {
						JExpression prefix = ((JThisExpression)self).getPrefix();
						self =
						new JExplicitConstructorInvocation(buildTokenReference(),
						prefix, "super", args); 
						}
						else if (self instanceof JThisExpression) {
						JExpression prefix = ((JThisExpression)self).getPrefix();
						self =
						new JExplicitConstructorInvocation(buildTokenReference(),
						prefix, "this", args);
						}
						else {
						self = new JMethodCallExpression(buildTokenReference(),
						self, args); 
						}
						
					}
					break;
				}
				default:
					if ((LA(1)==LBRACK) && (LA(2)==RBRACK)) {
						{
						int _cnt171=0;
						_loop171:
						do {
							if ((LA(1)==LBRACK)) {
								match(LBRACK);
								match(RBRACK);
								if ( inputState.guessing==0 ) {
									bounds++;
								}
							}
							else {
								if ( _cnt171>=1 ) { break _loop171; } else {throw new NoViableAltException(LT(1), getFilename());}
							}
							
							_cnt171++;
						} while (true);
						}
						match(DOT);
						match(LITERAL_class);
						if ( inputState.guessing==0 ) {
							
							self = new JClassExpression(buildTokenReference(), self, bounds);
							
						}
					}
					else if ((LA(1)==LBRACK) && (_tokenSet_9.member(LA(2)))) {
						match(LBRACK);
						expr=jExpression();
						match(RBRACK);
						if ( inputState.guessing==0 ) {
							
							self = new JArrayAccessExpression(buildTokenReference(),
							self, expr);
							
						}
					}
				else {
					break _loop172;
				}
				}
			} while (true);
			}
			{
			switch ( LA(1)) {
			case INC:
			{
				match(INC);
				if ( inputState.guessing==0 ) {
					
					self = new JPostfixExpression(buildTokenReference(),
					Constants.OPE_POSTINC, self);
					
				}
				break;
			}
			case DEC:
			{
				match(DEC);
				if ( inputState.guessing==0 ) {
					
					self = new JPostfixExpression(buildTokenReference(),
					Constants.OPE_POSTDEC, self);
					
				}
				break;
			}
			case SEMI:
			case STAR:
			case RBRACK:
			case RCURLY:
			case RPAREN:
			case COMMA:
			case ASSIGN:
			case COLON:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case SLASH_ASSIGN:
			case PERCENT_ASSIGN:
			case SR_ASSIGN:
			case BSR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case QUESTION:
			case LOR:
			case LAND:
			case BOR:
			case BXOR:
			case BAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case LITERAL_instanceof:
			case SL:
			case SR:
			case BSR:
			case PLUS:
			case MINUS:
			case SLASH:
			case PERCENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		{
			type=jBuiltInType();
			{
			_loop175:
			do {
				if ((LA(1)==LBRACK)) {
					match(LBRACK);
					match(RBRACK);
					if ( inputState.guessing==0 ) {
						bounds++;
					}
				}
				else {
					break _loop175;
				}
				
			} while (true);
			}
			match(DOT);
			match(LITERAL_class);
			if ( inputState.guessing==0 ) {
				
				type = ( bounds > 0 ? new ArrayType(type, bounds) : type );
				self = new JClassExpression(buildTokenReference(), type);
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final JExpression  jPrimaryExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		Token  ident = null;
		
		JExpression qualifier;
		
		
		{
		switch ( LA(1)) {
		case IDENT:
		{
			ident = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				
				self = new JNameExpression(buildTokenReference(), ident.getText());
				
			}
			break;
		}
		case LITERAL_new:
		{
			self=jNewExpression();
			break;
		}
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			self=jConstant();
			break;
		}
		case LITERAL_super:
		{
			match(LITERAL_super);
			if ( inputState.guessing==0 ) {
				
				self = new JSuperExpression(buildTokenReference());
				
			}
			break;
		}
		case LITERAL_true:
		{
			match(LITERAL_true);
			if ( inputState.guessing==0 ) {
				
				self = new JBooleanLiteral(buildTokenReference(), true);
				
			}
			break;
		}
		case LITERAL_false:
		{
			match(LITERAL_false);
			if ( inputState.guessing==0 ) {
				
				self = new JBooleanLiteral(buildTokenReference(), false);
				
			}
			break;
		}
		case LITERAL_this:
		{
			match(LITERAL_this);
			if ( inputState.guessing==0 ) {
				
				self = new JThisExpression(buildTokenReference() );
				
			}
			break;
		}
		case LITERAL_null:
		{
			match(LITERAL_null);
			if ( inputState.guessing==0 ) {
				
				self = new JNullLiteral(buildTokenReference());
				
			}
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			self=jAssignmentExpression();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				
				self = new JParenthesedExpression(buildTokenReference(), self);
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression  jQualifiedNewExpression(
		JExpression expr
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		String             identifier;
		JExpression[]      args;
		JArrayInitializer  init = null;
		JClassDeclaration  decl = null;
		CParseClassContext context = null;
		
		
		match(LITERAL_new);
		identifier=jIdentifier();
		{
		match(LPAREN);
		args=jArgList();
		match(RPAREN);
		{
		switch ( LA(1)) {
		case LCURLY:
		{
			if ( inputState.guessing==0 ) {
				context = CParseClassContext.getInstance();
			}
			jClassBlock(context);
			if ( inputState.guessing==0 ) {
				
				decl = new JClassDeclaration(buildTokenReference(),
				0,
				identifier,
				null,
				ClassOrInterfaceType.EMPTY,
				context.getFields(),
				context.getMethods(),
				context.getInnerClasses(),
				context.getBody(),
				getJavadocComment(),
				getStatementComment());
				context.release();
				
			}
			if ( inputState.guessing==0 ) {
				
				self = new JNewAnonymousClassExpression(buildTokenReference(),
				null,
				expr, identifier,
				args, decl);
				
			}
			break;
		}
		case SEMI:
		case DOT:
		case STAR:
		case LBRACK:
		case RBRACK:
		case RCURLY:
		case LPAREN:
		case RPAREN:
		case COMMA:
		case ASSIGN:
		case COLON:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case SLASH_ASSIGN:
		case PERCENT_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		case QUESTION:
		case LOR:
		case LAND:
		case BOR:
		case BXOR:
		case BAND:
		case NOT_EQUAL:
		case EQUAL:
		case LT:
		case GT:
		case LE:
		case GE:
		case LITERAL_instanceof:
		case SL:
		case SR:
		case BSR:
		case PLUS:
		case MINUS:
		case SLASH:
		case PERCENT:
		case INC:
		case DEC:
		{
			if ( inputState.guessing==0 ) {
				
				self = new JNewObjectExpression(buildTokenReference(),
				null,
				expr, identifier,
				args);
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		return self;
	}
	
	public final JExpression[]  jArgList(
		
	) throws RecognitionException, TokenStreamException {
		JExpression[] self = JExpression.EMPTY;
		
		
		{
		switch ( LA(1)) {
		case IDENT:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LPAREN:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case INTEGER_LITERAL:
		case CHARACTER_LITERAL:
		case STRING_LITERAL:
		case REAL_LITERAL:
		{
			self=jExpressionList();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
/** object instantiation.
 *  Trees are built as illustrated by the following input/tree pairs:
 *  
 *  new T()
 *  
 *  new
 *   |
 *   T --  ELIST
 *           |
 *          arg1 -- arg2 -- .. -- argn
 *  
 *  new int[]
 *
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR
 *  
 *  new int[] {1,2}
 *
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR -- ARRAY_INIT
 *                                  |
 *                                EXPR -- EXPR
 *                                  |      |
 *                                  1      2
 *  
 *  new int[3]
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR
 *                |
 *              EXPR
 *                |
 *                3
 *  
 *  new int[1][2]
 *  
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR
 *               |
 *         ARRAY_DECLARATOR -- EXPR
 *               |              |
 *             EXPR             1
 *               |
 *               2
 *  
 */
	public final JExpression  jNewExpression(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		
		Type              type;
		JExpression[]      args;
		JArrayInitializer  init = null;
		JClassDeclaration  decl = null;
		CParseClassContext context = null;
		
		
		match(LITERAL_new);
		type=jType();
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			args=jArgList();
			match(RPAREN);
			{
			switch ( LA(1)) {
			case LCURLY:
			{
				if ( inputState.guessing==0 ) {
					context = CParseClassContext.getInstance();
				}
				jClassBlock(context);
				if ( inputState.guessing==0 ) {
					
					decl = new JClassDeclaration(buildTokenReference(),
					0,
					((ClassOrInterfaceType)type)
					.getQualifiedName(),
					null,
					ClassOrInterfaceType.EMPTY,
					context.getFields(),
					context.getMethods(),
					context.getInnerClasses(),
					context.getBody(),
					getJavadocComment(),
					getStatementComment());
					context.release();
					
				}
				if ( inputState.guessing==0 ) {
					
					self = new JNewAnonymousClassExpression(buildTokenReference(),
					(ClassOrInterfaceType)type,
					null, null,
					args, decl);
					
				}
				break;
			}
			case SEMI:
			case DOT:
			case STAR:
			case LBRACK:
			case RBRACK:
			case RCURLY:
			case LPAREN:
			case RPAREN:
			case COMMA:
			case ASSIGN:
			case COLON:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case SLASH_ASSIGN:
			case PERCENT_ASSIGN:
			case SR_ASSIGN:
			case BSR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case QUESTION:
			case LOR:
			case LAND:
			case BOR:
			case BXOR:
			case BAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case LITERAL_instanceof:
			case SL:
			case SR:
			case BSR:
			case PLUS:
			case MINUS:
			case SLASH:
			case PERCENT:
			case INC:
			case DEC:
			{
				if ( inputState.guessing==0 ) {
					
					self = new JNewObjectExpression(buildTokenReference(),
					(ClassOrInterfaceType)type,
					null, null,
					args);
					
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case LBRACK:
		{
			args=jNewArrayDeclarator();
			{
			switch ( LA(1)) {
			case LCURLY:
			{
				init=jArrayInitializer();
				break;
			}
			case SEMI:
			case DOT:
			case STAR:
			case LBRACK:
			case RBRACK:
			case RCURLY:
			case LPAREN:
			case RPAREN:
			case COMMA:
			case ASSIGN:
			case COLON:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case SLASH_ASSIGN:
			case PERCENT_ASSIGN:
			case SR_ASSIGN:
			case BSR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case QUESTION:
			case LOR:
			case LAND:
			case BOR:
			case BXOR:
			case BAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case LITERAL_instanceof:
			case SL:
			case SR:
			case BSR:
			case PLUS:
			case MINUS:
			case SLASH:
			case PERCENT:
			case INC:
			case DEC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
				self =
				new JNewArrayExpression(buildTokenReference(),
				type,
				new JArrayDimsAndInits
				(buildTokenReference(),  args, init));
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final JExpression  jConstant(
		
	) throws RecognitionException, TokenStreamException {
		JExpression self = null;
		
		Token  i = null;
		Token  c = null;
		Token  s = null;
		Token  r = null;
		
		switch ( LA(1)) {
		case INTEGER_LITERAL:
		{
			i = LT(1);
			match(INTEGER_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JOrdinalLiteral(buildTokenReference(), i.getText());
			}
			break;
		}
		case CHARACTER_LITERAL:
		{
			c = LT(1);
			match(CHARACTER_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JCharLiteral(buildTokenReference(), c.getText());
			}
			break;
		}
		case STRING_LITERAL:
		{
			s = LT(1);
			match(STRING_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JStringLiteral(buildTokenReference(), s.getText());
			}
			break;
		}
		case REAL_LITERAL:
		{
			r = LT(1);
			match(REAL_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JRealLiteral(buildTokenReference(), r.getText());
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final JExpression[]  jNewArrayDeclarator(
		
	) throws RecognitionException, TokenStreamException {
		JExpression[] self = null;
		
		
		boolean     unspec = false;
		List        list = new ArrayList(10);
		JExpression exp  = null;
		
		
		{
		int _cnt190=0;
		_loop190:
		do {
			if ((LA(1)==LBRACK) && (_tokenSet_18.member(LA(2)))) {
				match(LBRACK);
				{
				if (((_tokenSet_9.member(LA(1))))&&( !unspec )) {
					exp=jExpression();
				}
				else if ((LA(1)==RBRACK)) {
					if ( inputState.guessing==0 ) {
						unspec = true;
					}
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					list.add(exp); exp = null;
				}
			}
			else {
				if ( _cnt190>=1 ) { break _loop190; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt190++;
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (JExpression[])list.toArray(new JExpression[list.size()]);
			
		}
		return self;
	}
	
	public final int  jReservedKeyword(
		
	) throws RecognitionException, TokenStreamException {
		int self = 0;
		
		
		
		
		switch ( LA(1)) {
		case LITERAL_const:
		{
			match(LITERAL_const);
			break;
		}
		case LITERAL_goto:
		{
			match(LITERAL_goto);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"package\"",
		"SEMI",
		"\"import\"",
		"IDENT",
		"DOT",
		"STAR",
		"LBRACK",
		"RBRACK",
		"\"boolean\"",
		"\"byte\"",
		"\"char\"",
		"\"double\"",
		"\"float\"",
		"\"int\"",
		"\"long\"",
		"\"short\"",
		"\"void\"",
		"\"public\"",
		"\"protected\"",
		"\"private\"",
		"\"static\"",
		"\"abstract\"",
		"\"final\"",
		"\"native\"",
		"\"synchronized\"",
		"\"strictfp\"",
		"\"transient\"",
		"\"volatile\"",
		"\"class\"",
		"\"extends\"",
		"\"interface\"",
		"LCURLY",
		"RCURLY",
		"\"implements\"",
		"LPAREN",
		"RPAREN",
		"COMMA",
		"ASSIGN",
		"\"throws\"",
		"COLON",
		"\"if\"",
		"\"else\"",
		"\"while\"",
		"\"do\"",
		"\"break\"",
		"\"continue\"",
		"\"return\"",
		"\"throw\"",
		"\"switch\"",
		"\"case\"",
		"\"default\"",
		"\"for\"",
		"\"try\"",
		"\"finally\"",
		"\"catch\"",
		"PLUS_ASSIGN",
		"MINUS_ASSIGN",
		"STAR_ASSIGN",
		"SLASH_ASSIGN",
		"PERCENT_ASSIGN",
		"SR_ASSIGN",
		"BSR_ASSIGN",
		"SL_ASSIGN",
		"BAND_ASSIGN",
		"BXOR_ASSIGN",
		"BOR_ASSIGN",
		"QUESTION",
		"LOR",
		"LAND",
		"BOR",
		"BXOR",
		"BAND",
		"NOT_EQUAL",
		"EQUAL",
		"LT",
		"GT",
		"LE",
		"GE",
		"\"instanceof\"",
		"SL",
		"SR",
		"BSR",
		"PLUS",
		"MINUS",
		"SLASH",
		"PERCENT",
		"INC",
		"DEC",
		"BNOT",
		"LNOT",
		"\"this\"",
		"\"super\"",
		"\"true\"",
		"\"false\"",
		"\"null\"",
		"\"new\"",
		"INTEGER_LITERAL",
		"CHARACTER_LITERAL",
		"STRING_LITERAL",
		"REAL_LITERAL",
		"\"const\"",
		"\"goto\""
	};
	
	private static final long _tokenSet_0_data_[] = { 25767706656L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 25769799808L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { 300647708032L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long _tokenSet_3_data_[] = { 2093184L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	private static final long _tokenSet_4_data_[] = { 1408L, 0L };
	public static final BitSet _tokenSet_4 = new BitSet(_tokenSet_4_data_);
	private static final long _tokenSet_5_data_[] = { 3298534884384L, 0L };
	public static final BitSet _tokenSet_5 = new BitSet(_tokenSet_5_data_);
	private static final long _tokenSet_6_data_[] = { 117041131581075616L, 1099457101824L, 0L, 0L };
	public static final BitSet _tokenSet_6 = new BitSet(_tokenSet_6_data_);
	private static final long _tokenSet_7_data_[] = { 4294963328L, 0L };
	public static final BitSet _tokenSet_7 = new BitSet(_tokenSet_7_data_);
	private static final long _tokenSet_8_data_[] = { 4294964608L, 0L };
	public static final BitSet _tokenSet_8 = new BitSet(_tokenSet_8_data_);
	private static final long _tokenSet_9_data_[] = { 274880000128L, 1099457101824L, 0L, 0L };
	public static final BitSet _tokenSet_9 = new BitSet(_tokenSet_9_data_);
	private static final long _tokenSet_10_data_[] = { -576458278400165984L, 1099511627775L, 0L, 0L };
	public static final BitSet _tokenSet_10 = new BitSet(_tokenSet_10_data_);
	private static final long _tokenSet_11_data_[] = { 144097982436864160L, 1099457101824L, 0L, 0L };
	public static final BitSet _tokenSet_11 = new BitSet(_tokenSet_11_data_);
	private static final long _tokenSet_12_data_[] = { -6193342842976L, 1099511627775L, 0L, 0L };
	public static final BitSet _tokenSet_12 = new BitSet(_tokenSet_12_data_);
	private static final long _tokenSet_13_data_[] = { 9070973022336L, 1099457101824L, 0L, 0L };
	public static final BitSet _tokenSet_13 = new BitSet(_tokenSet_13_data_);
	private static final long _tokenSet_14_data_[] = { -576457178888538208L, 1099511627775L, 0L, 0L };
	public static final BitSet _tokenSet_14 = new BitSet(_tokenSet_14_data_);
	private static final long _tokenSet_15_data_[] = { 512L, 50331648L, 0L, 0L };
	public static final BitSet _tokenSet_15 = new BitSet(_tokenSet_15_data_);
	private static final long _tokenSet_16_data_[] = { 274880000128L, 1098437885952L, 0L, 0L };
	public static final BitSet _tokenSet_16 = new BitSet(_tokenSet_16_data_);
	private static final long _tokenSet_17_data_[] = { -576447764320223328L, 1099511627775L, 0L, 0L };
	public static final BitSet _tokenSet_17 = new BitSet(_tokenSet_17_data_);
	private static final long _tokenSet_18_data_[] = { 274880002176L, 1099457101824L, 0L, 0L };
	public static final BitSet _tokenSet_18 = new BitSet(_tokenSet_18_data_);
	
	}
