/*
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.type;

import at.dms.compiler.UnpositionedError;

/**
 * Abstraction of integral types in Java.
 * See JLS2 4.2.1 and 4.2.2 for a description of integral types.
 *
 * Integral types are: byte, short, int, long
 */
public class IntegralType
    extends NumericType
{
    /**
     * Constructor.
     *
     * @param typeID
     * The ident (int value) of this type.
     */
    protected IntegralType(int typeID)
    {
        super(typeID);
        assert(typeID == TID_BYTE ||
               typeID == TID_CHAR ||
               typeID == TID_INT ||
               typeID == TID_LONG ||
               typeID == TID_SHORT);
    }

    /**
     * Returns whether this type is an integral type.
     */
    public boolean isIntegral()
    {
        return true;
    }
}

