/*
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.type;

/**
 * Abstraction of long type in Java.
 * See JLS2 4.2.1 and 4.2.2 for a description of integral types.
 */
public final class LongType
    extends IntegralType
{
    /**
     * Constructor.
     */
    public LongType()
    {
        super(TID_LONG);
    }

    /**
     * Returns whether this type is an integral type.
     */
    public boolean isIntegral()
    {
        return true;
    }
}

