// $ANTLR 2.7.1: "Lexgen.g" -> "LexgenParser.java"$

package at.dms.lexgen;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

import java.util.ArrayList;
import java.util.List;

public class LexgenParser extends antlr.LLkParser
       implements LexgenTokenTypes
 {

protected LexgenParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public LexgenParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected LexgenParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public LexgenParser(TokenStream lexer) {
  this(lexer,2);
}

public LexgenParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final DefinitionFile  aCompilationUnit(
		String sourceFile
	) throws RecognitionException, TokenStreamException {
		DefinitionFile self;
		
		
		String prefix = null;
		String packageName = null;
		String vocabulary = null;
		List definitions = new ArrayList();
		TokenDefinition def;
		
		
		{
		switch ( LA(1)) {
		case 4:
		{
			match(4);
			prefix=aIdentifier();
			break;
		}
		case 5:
		case 6:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case 5:
		{
			match(5);
			packageName=aName();
			break;
		}
		case 6:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(6);
		vocabulary=aIdentifier();
		{
		int _cnt5=0;
		_loop5:
		do {
			if (((LA(1) >= 10 && LA(1) <= 12))) {
				def=aTokenDefinition();
				definitions.add(def);
			}
			else {
				if ( _cnt5>=1 ) { break _loop5; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt5++;
		} while (true);
		}
		
		self = new DefinitionFile(sourceFile, packageName, vocabulary,
		prefix, definitions);
		
		return self;
	}
	
	public final String  aIdentifier(
		
	) throws RecognitionException, TokenStreamException {
		String self = null;
		
		Token  t = null;
		
		t = LT(1);
		match(IDENT);
		self = t.getText();
		return self;
	}
	
	public final String  aName(
		
	) throws RecognitionException, TokenStreamException {
		String self;
		
		
		String ident;
		
		
		ident=aIdentifier();
		self = ident;
		{
		_loop9:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				ident=aIdentifier();
				self += "." + ident;
			}
			else {
				break _loop9;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final TokenDefinition  aTokenDefinition(
		
	) throws RecognitionException, TokenStreamException {
		TokenDefinition self;
		
		
		int tokenType = TokenDefinition.OTHER;
		String ident;
		String value = null;
		
		
		{
		switch ( LA(1)) {
		case 10:
		{
			match(10);
			tokenType = TokenDefinition.LITERAL;
			break;
		}
		case 11:
		{
			match(11);
			tokenType = TokenDefinition.KEYWORD;
			break;
		}
		case 12:
		{
			match(12);
			tokenType = TokenDefinition.OTHER;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		ident=aIdentifier();
		{
		switch ( LA(1)) {
		case STRING:
		{
			value=aString();
			break;
		}
		case EOF:
		case 10:
		case 11:
		case 12:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		self = new TokenDefinition(tokenType, ident, value);
		return self;
	}
	
	public final String  aString(
		
	) throws RecognitionException, TokenStreamException {
		String self;
		
		Token  t = null;
		
		t = LT(1);
		match(STRING);
		self = t.getText();
		return self;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"@prefix\"",
		"\"@package\"",
		"\"@vocabulary\"",
		"IDENT",
		"DOT",
		"STRING",
		"\"@literal\"",
		"\"@keyword\"",
		"\"@token\""
	};
	
	
	}
